#! /bin/sh

# @(#) postremove	1.2 94/03/14 13:54:56

PATH="/usr/bin:/usr/sbin:${PATH}"
export PATH
NAMEMAJOR="${BASEDIR}/etc/name_to_major"
MINORPERM="${BASEDIR}/etc/minor_perm"
DEVLINKTB="$BASEDIR/etc/devlink.tab"

rm -f /dev/tcx? /kernel/drv/tcx  
 
# Find any /dev/fb files linked to tcx and remove them also 
FBS=`ls -l /dev/fb* | fgrep fbs/tcx | awk '{print $9}'`
if [ "$FBS" != "" ]
then
	/bin/rm -f $FBS
fi

if test ! -f ${NAMEMAJOR} -o ! -w ${NAMEMAJOR}
then
	echo "rem_major: data file \'${NAMEMAJOR}\' is missing/inacessible." >&2
	exit 1
fi

if test ! -f ${MINORPERM} -o ! -w ${MINORPERM}
then
	echo "rem_minor: data file \'${MINORPERM}\' is missing/inacessible." >&2
	exit 1
fi

if test ! -f ${DEVLINKTB} -o ! -w ${DEVLINKTB}; then
	echo "rem_devlink: data file ${DEVLINKTB} is missing/inacessible." >&2
	exit 1
fi

trap "rm -f /tmp/$$.*;exit" 0 1 2 3 13 15
TMP=/tmp/$$

# removes major numbers from system for device drivers
# Usage:
#	rem_major name1 name2 name3 name4 ....

rem_major()
{
sort +1 -2n ${NAMEMAJOR} | nawk '#
NR == 1	{n=split(namelist,x)
	 if (n < 1)
	    exit(1)
	 for (i=1; i<=n; i++)
	    chklist[x[i]]++
	}
	{if ($1 in chklist)
		print
	}
' namelist="$*" - > $TMP.del
if [ -s $TMP.del ]
then
    fgrep -v -x -f $TMP.del ${NAMEMAJOR} | sort +1 -2n -o ${NAMEMAJOR}
fi
}


# removes minor permissions from system for device drivers
# Usage:
#	rem_minor name1 name2 name3 name4 ....
#    i.e.
#	rem_minor 'sd:*' 'sd:a'

rem_minor()
{
for p in "$@"
do echo "$p"
done | nawk '#
FILENAME != "-"	{permtab[$1] = $0;next}
FILENAME == "-"	{
		 if ($1 !~ /:/) {
			 printf("Bad name:minor pair: %s, skipping.\n", $1)
			 next
		 }
		 if ($1 in permtab)
		     print permtab[$1] >> permdel
		 next
		}
' permdel=$TMP.perm ${MINORPERM} - >&2

if [ -s $TMP.perm ]
then
    fgrep -v -x -f $TMP.perm ${MINORPERM} | sort +0 -1 -o ${MINORPERM}
fi
}

# removes entries from devlink.tab file
# Usage:
#	rem_devlink spec1 spec2 spec3 spec4 ...
#
#	where each <spec> is:
#	    <devfs-spec> <dev-name> <dev-link>
#
#    i.e.
#	rem_devlink 'type=ddi_display;name=SUNW,tcx' 'fbs/\\M0' 'tcx\\N0'	
#

rem_devlink()
{
while test $# -ge 3
do
echo "$1	$2	$3"
shift 3
done | nawk '-F	' '#
FILENAME != "-"		{devlinktab[$1] = $0;next}
FILENAME == "-"		{if ($1 in devlinktab)
			     print devlinktab[$1] >> devlinktmp
			}
' devlinktmp=$TMP.devlink ${DEVLINKTB} - >&2

if [ -s $TMP.devlink ]
then
	fgrep -v -x -f $TMP.devlink ${DEVLINKTB} > $TMP.devlinknew && \
	mv $TMP.devlinknew ${DEVLINKTB}
fi
}

if [ "$BASEDIR" = "/" ]
then
	# 
	# We're modifying the running system
	#
	if /usr/sbin/prtconf -vp | /bin/fgrep -s "'SUNW,tcx'"
	then
		/usr/sbin/rem_drv tcx
		rc=$?
		rem_devlink 'type=ddi_display;name=SUNW,tcx' 'fbs/\M0' 'tcx\N0'
		test $rc -eq 0 && exit 0
		#
		# fall through if error in rem_drv
		#
	fi
fi

rem_major tcx
rem_minor 'tcx:* 0666 root sys' 'SUNW,tcx:* 0666 root sys'
rem_devlink 'type=ddi_display;name=SUNW,tcx' 'fbs/\M0' 'tcx\N0'
touch ${BASEDIR}/reconfigure

exit 0
